// 2022, Dr. Martin Koch
//
//This program sends joint position angles (in degrees) via serial com
//as a demo for connecting ROBOTARM_GAME_V4
//This program uses a PS2 dualshock controller to move (rotate) each section of the robot arm game provided by UATEA 1 team.
/*Super amazing PS2 controller Arduino Library v1.8
*		details and example sketch: 
*			http://www.billporter.info/?p=240
*
*    Original code by Shutter on Arduino Forums
*
*    Revamped, made into lib by and supporting continued development:
*              Bill Porter
*              www.billporter.info  */ //Credit to the library creator
#include <PS2X_lib.h>   //we add the PS2 controller library
PS2X ps2x; // create PS2 Controller Class

// Define angle variables
float js[5] = {0,0,0,0,0};   // we define a j_angles array so we can work with the array to move forward or backwards through the sections of the robot arm
float j0_angle = 0;          // the angle we are going to send
float j1_angle = 0;
float j2_angle = 0;
float j3_angle = 0;
float j4_angle = 0;

// Define angle limits
float minrot0 = -360, maxrot0 = 360;
float minrot1 = 30, maxrot1 = 90;
float minrot2 = -120, maxrot2 = -60;
float minrot3 = -360, maxrot3 = 360;
float minrot4 = -60, maxrot4 = 60;
float mini = 0, maxi = 4;   //we declare the maximum and minimum values to 'i' that will be the controller to move in the arrays of angles and maximum and minimums
int i = 0; 
byte type = 0;
byte vibrate = 0;


void setup() {
  Serial.begin(115200); // activate Serial Communication
  Serial.begin(57600);

 ps2x.config_gamepad(13,11,10,12, true, true);   //setup pins and settings:  GamePad(clock, command, attention, data, Pressures?, Rumble?) check for error
  
  
}

void loop() {
  
  if(ps2x.ButtonPressed(PSB_PAD_UP)){             //will be TRUE if button was JUST pressed
      i++;
      }
  else if(ps2x.ButtonPressed(PSB_PAD_DOWN)){
      i--;
      }
  else if(ps2x.Button(PSB_PAD_LEFT)){                  //will be TRUE as long as button is pressed
      js[i] -=5;
      }   
   else if(ps2x.Button(PSB_PAD_RIGHT)){
      js[i] +=5;
      }   
  j0_angle = js[0];                               //we give the data that states de array of js to the js that the program will read
  j1_angle = js[1];
  j2_angle = js[2];
  j3_angle = js[3];
  j4_angle = js[4];
  // Create messages and send via serial
  Serial.println("J0_" + String(j0_angle, 3)); // Send Angle data. Format is "A_123.456"
  Serial.println("J1_" + String(j1_angle, 3));
  Serial.println("J2_" + String(j2_angle, 3));
  Serial.println("J3_" + String(j3_angle, 3));
  Serial.println("J4_" + String(j4_angle, 3));
 
  Serial.flush();    // wait for messages to be sent
  delay(5000);          // wait for 5 seconds
}
